/*
 * LinkedCell_View.hpp
 *
 *  Created on: Nov 15, 2011
 *      Author: heber
 */

#ifndef LINKEDCELL_VIEW_HPP_
#define LINKEDCELL_VIEW_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "LinkedCell/types.hpp"

class TesselPoint;
class Vector;

namespace LinkedCell {

  class LinkedCell_Model;

  /** This is the view of the MVC ansatz for the LinkedCell structure.
   *
   * \sa linkedcell
   *
   * The view contains high-level functions for the user to use. He does not
   * need to know anything about the inner workings.
   *
   */
  class LinkedCell_View
  {
  public:
    LinkedCell_View(const LinkedCell_Model &_LC);
    ~LinkedCell_View();

    LinkedList getAllNeighbors(const double radius, const Vector &center) const;
    LinkedList getPointsInsideSphere(const double radius, const Vector &center) const;
  private:
    const LinkedCell_Model &LC;
  };

}

#endif /* LINKEDCELL_VIEW_HPP_ */
